----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:10:50 11/24/2013 
-- Design Name: 
-- Module Name:    sine_rom_memory - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;
use ieee.std_logic_unsigned.all;
-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

---------------------------------------------------------------------------------------------------------------------------------
--this module stores sine samples in BRAM, bit width 10, N = 512
---------------------------------------------------------------------------------------------------------------------------------

entity sine_rom_memory is
    Port ( phase_in 			: in  STD_LOGIC_VECTOR (9 downto 0);
           clk,rst 			: in  STD_LOGIC;
           sine_out 			: out  STD_LOGIC_VECTOR (9 downto 0));
end sine_rom_memory;

architecture Behavioral of sine_rom_memory is
signal sine_out_1 			: std_logic_vector(11 downto 0);
signal q_phase_in 			: std_logic_vector (9 downto 0);
signal phase_in_1 			: std_logic_vector(9 downto 0);
--signal phase_diff,phase_diff_2 : std_logic_vector(15 downto 0);
type romtype is array (0 to 511) of std_logic_vector(11 downto 0);
constant rom : romtype := (


X"200",X"203",X"206",X"209",X"20D",X"210",X"213",X"216",X"219",X"21C",X"21F",X"222",X"226",X"229",X"22C",X"22F",X"232",X"235",X"238",X"23B",X"23F",X"242",X"245",X"248",X"24B",X"24E",X"251",X"254",X"257",X"25A",X"25E",X"261",X"264",X"267",X"26A",X"26D",X"270",X"273",X"276",X"279",X"27C",X"27F",X"282",X"285",X"288",X"28B",X"28E",X"291",X"294",X"297",X"29A",X"29D",X"2A0",X"2A3",X"2A6",X"2A9",X"2AC",X"2AF",X"2B2",X"2B5",X"2B8",X"2BB",X"2BE",X"2C1",X"2C4",X"2C6",X"2C9",X"2CC",X"2CF",X"2D2",X"2D5",X"2D8",X"2DA",X"2DD",X"2E0",X"2E3",X"2E6",X"2E9",X"2EB",X"2EE",X"2F1",X"2F4",X"2F6",X"2F9",X"2FC",X"2FF",X"301",X"304",X"307",X"309",X"30C",X"30F",X"311",X"314",X"317",X"319",X"31C",X"31E",X"321",X"324",X"326",X"329",X"32B",X"32E",X"330",X"333",X"335",X"338",X"33A",X"33D",X"33F",X"342",X"344",X"347",X"349",X"34B",X"34E",X"350",X"352",X"355",X"357",X"359",X"35C",X"35E",X"360",X"363",X"365",X"367",X"369",X"36C",X"36E",X"370",X"372",X"374",X"376",X"379",X"37B",X"37D",X"37F",X"381",X"383",X"385",X"387",X"389",X"38B",X"38D",X"38F",X"391",X"393",X"395",X"397",X"399",X"39A",X"39C",X"39E",X"3A0",X"3A2",X"3A4",X"3A5",X"3A7",X"3A9",X"3AB",X"3AC",X"3AE",X"3B0",X"3B1",X"3B3",X"3B5",X"3B6",X"3B8",X"3B9",X"3BB",X"3BD",X"3BE",X"3C0",X"3C1",X"3C3",X"3C4",X"3C6",X"3C7",X"3C8",X"3CA",X"3CB",X"3CD",X"3CE",X"3CF",X"3D1",X"3D2",X"3D3",X"3D4",X"3D6",X"3D7",X"3D8",X"3D9",X"3DA",X"3DC",X"3DD",X"3DE",X"3DF",X"3E0",X"3E1",X"3E2",X"3E3",X"3E4",X"3E5",X"3E6",X"3E7",X"3E8",X"3E9",X"3EA",X"3EB",X"3EC",X"3EC",X"3ED",X"3EE",X"3EF",X"3F0",X"3F0",X"3F1",X"3F2",X"3F3",X"3F3",X"3F4",X"3F5",X"3F5",X"3F6",X"3F6",X"3F7",X"3F7",X"3F8",X"3F9",X"3F9",X"3F9",X"3FA",X"3FA",X"3FB",X"3FB",X"3FC",X"3FC",X"3FC",X"3FD",X"3FD",X"3FD",X"3FD",X"3FE",X"3FE",X"3FE",X"3FE",X"3FE",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FF",X"3FE",X"3FE",X"3FE",X"3FE",X"3FE",X"3FD",X"3FD",X"3FD",X"3FD",X"3FC",X"3FC",X"3FC",X"3FB",X"3FB",X"3FA",X"3FA",X"3F9",X"3F9",X"3F9",X"3F8",X"3F7",X"3F7",X"3F6",X"3F6",X"3F5",X"3F5",X"3F4",X"3F3",X"3F3",X"3F2",X"3F1",X"3F0",X"3F0",X"3EF",X"3EE",X"3ED",X"3EC",X"3EC",X"3EB",X"3EA",X"3E9",X"3E8",X"3E7",X"3E6",X"3E5",X"3E4",X"3E3",X"3E2",X"3E1",X"3E0",X"3DF",X"3DE",X"3DD",X"3DC",X"3DA",X"3D9",X"3D8",X"3D7",X"3D6",X"3D4",X"3D3",X"3D2",X"3D1",X"3CF",X"3CE",X"3CD",X"3CB",X"3CA",X"3C8",X"3C7",X"3C6",X"3C4",X"3C3",X"3C1",X"3C0",X"3BE",X"3BD",X"3BB",X"3B9",X"3B8",X"3B6",X"3B5",X"3B3",X"3B1",X"3B0",X"3AE",X"3AC",X"3AB",X"3A9",X"3A7",X"3A5",X"3A4",X"3A2",X"3A0",X"39E",X"39C",X"39A",X"399",X"397",X"395",X"393",X"391",X"38F",X"38D",X"38B",X"389",X"387",X"385",X"383",X"381",X"37F",X"37D",X"37B",X"379",X"376",X"374",X"372",X"370",X"36E",X"36C",X"369",X"367",X"365",X"363",X"360",X"35E",X"35C",X"359",X"357",X"355",X"352",X"350",X"34E",X"34B",X"349",X"347",X"344",X"342",X"33F",X"33D",X"33A",X"338",X"335",X"333",X"330",X"32E",X"32B",X"329",X"326",X"324",X"321",X"31E",X"31C",X"319",X"317",X"314",X"311",X"30F",X"30C",X"309",X"307",X"304",X"301",X"2FF",X"2FC",X"2F9",X"2F6",X"2F4",X"2F1",X"2EE",X"2EB",X"2E9",X"2E6",X"2E3",X"2E0",X"2DD",X"2DA",X"2D8",X"2D5",X"2D2",X"2CF",X"2CC",X"2C9",X"2C6",X"2C4",X"2C1",X"2BE",X"2BB",X"2B8",X"2B5",X"2B2",X"2AF",X"2AC",X"2A9",X"2A6",X"2A3",X"2A0",X"29D",X"29A",X"297",X"294",X"291",X"28E",X"28B",X"288",X"285",X"282",X"27F",X"27C",X"279",X"276",X"273",X"270",X"26D",X"26A",X"267",X"264",X"261",X"25E",X"25A",X"257",X"254",X"251",X"24E",X"24B",X"248",X"245",X"242",X"23F",X"23B",X"238",X"235",X"232",X"22F",X"22C",X"229",X"226",X"222",X"21F",X"21C",X"219",X"216",X"213",X"210",X"20D",X"209",X"206",X"203"
 
);
begin

process(phase_in,sine_out_1,q_phase_in) 
begin
	phase_in_1 <= (others => '0');
	sine_out <= (others => '0');
	if q_phase_in < std_logic_vector(to_unsigned(512,10)) then
		phase_in_1(9 downto 0) <= phase_in;
		sine_out <= sine_out_1(9 downto 0);
	elsif q_phase_in = std_logic_vector(to_unsigned(512,10)) or q_phase_in > std_logic_vector(to_unsigned(512,10)) then
		phase_in_1(9 downto 0) <= std_logic_vector(unsigned(q_phase_in(9 downto 0)) - to_unsigned(512,10));
		sine_out <= std_logic_vector(to_unsigned(1023,10) - unsigned(sine_out_1(9 downto 0)));
	end if;
end process;	

process(clk,rst)
begin 
	if rst = '1' then
		q_phase_in <= (others => '0');
	elsif rising_edge(clk) then
		q_phase_in <= phase_in;
	end if;
end process;	
 
process(clk)  
begin 
	if rising_edge(clk) then
		sine_out_1 <= rom(to_integer(unsigned(phase_in_1(8 downto 0))));
	end if;
end process;
end Behavioral;

